diff --git a/compiler/iface/BuildTyCl.lhs b/compiler/iface/BuildTyCl.lhs
index 38bb930..1019707 100644
--- a/compiler/iface/BuildTyCl.lhs
+++ b/compiler/iface/BuildTyCl.lhs
@@ -4,12 +4,6 @@
 %
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module BuildTyCl (
         buildSynTyCon,
@@ -42,7 +36,7 @@ import UniqSupply
 import Util
 import Outputable
 \end{code}
-	
+        
 
 \begin{code}
 ------------------------------------------------------
@@ -66,7 +60,7 @@ mkDataTyConRhs cons
   = DataTyCon {
         data_cons = cons,
         is_enum = not (null cons) && all is_enum_con cons
-		  -- See Note [Enumeration types] in TyCon
+                  -- See Note [Enumeration types] in TyCon
     }
   where
     is_enum_con con
@@ -79,13 +73,13 @@ mkNewTyConRhs :: Name -> TyCon -> DataCon -> TcRnIf m n AlgTyConRhs
 --   We pass the Name of the parent TyCon, as well as the TyCon itself,
 --   because the latter is part of a knot, whereas the former is not.
 mkNewTyConRhs tycon_name tycon con 
-  = do	{ co_tycon_name <- newImplicitBinder tycon_name mkNewTyCoOcc
-	; let co_tycon = mkNewTypeCo co_tycon_name tycon etad_tvs etad_roles etad_rhs
-	; traceIf (text "mkNewTyConRhs" <+> ppr co_tycon)
-	; return (NewTyCon { data_con    = con, 
-		       	     nt_rhs      = rhs_ty,
-		       	     nt_etad_rhs = (etad_tvs, etad_rhs),
- 		       	     nt_co 	 = co_tycon } ) }
+  = do  { co_tycon_name <- newImplicitBinder tycon_name mkNewTyCoOcc
+        ; let co_tycon = mkNewTypeCo co_tycon_name tycon etad_tvs etad_roles etad_rhs
+        ; traceIf (text "mkNewTyConRhs" <+> ppr co_tycon)
+        ; return (NewTyCon { data_con    = con, 
+                             nt_rhs      = rhs_ty,
+                             nt_etad_rhs = (etad_tvs, etad_rhs),
+                             nt_co       = co_tycon } ) }
                              -- Coreview looks through newtypes with a Nothing
                              -- for nt_co, or uses explicit coercions otherwise
   where
@@ -93,89 +87,89 @@ mkNewTyConRhs tycon_name tycon con
     roles  = tyConRoles tycon
     inst_con_ty = applyTys (dataConUserType con) (mkTyVarTys tvs)
     rhs_ty = ASSERT( isFunTy inst_con_ty ) funArgTy inst_con_ty
-	-- Instantiate the data con with the 
-	-- type variables from the tycon
-	-- NB: a newtype DataCon has a type that must look like
-	--        forall tvs.  <arg-ty> -> T tvs
-	-- Note that we *can't* use dataConInstOrigArgTys here because
-	-- the newtype arising from   class Foo a => Bar a where {}
-  	-- has a single argument (Foo a) that is a *type class*, so
-	-- dataConInstOrigArgTys returns [].
+        -- Instantiate the data con with the 
+        -- type variables from the tycon
+        -- NB: a newtype DataCon has a type that must look like
+        --        forall tvs.  <arg-ty> -> T tvs
+        -- Note that we *can't* use dataConInstOrigArgTys here because
+        -- the newtype arising from   class Foo a => Bar a where {}
+        -- has a single argument (Foo a) that is a *type class*, so
+        -- dataConInstOrigArgTys returns [].
 
     etad_tvs   :: [TyVar]  -- Matched lazily, so that mkNewTypeCo can
     etad_roles :: [Role]   -- return a TyCon without pulling on rhs_ty
     etad_rhs   :: Type     -- See Note [Tricky iface loop] in LoadIface
     (etad_tvs, etad_roles, etad_rhs) = eta_reduce (reverse tvs) (reverse roles) rhs_ty
  
-    eta_reduce :: [TyVar]	-- Reversed
+    eta_reduce :: [TyVar]       -- Reversed
                -> [Role]        -- also reversed
-	       -> Type		-- Rhs type
-	       -> ([TyVar], [Role], Type)  -- Eta-reduced version
+               -> Type          -- Rhs type
+               -> ([TyVar], [Role], Type)  -- Eta-reduced version
                                            -- (tyvars in normal order)
     eta_reduce (a:as) (_:rs) ty | Just (fun, arg) <- splitAppTy_maybe ty,
-			          Just tv <- getTyVar_maybe arg,
-			          tv == a,
-			          not (a `elemVarSet` tyVarsOfType fun)
-			        = eta_reduce as rs fun
+                                  Just tv <- getTyVar_maybe arg,
+                                  tv == a,
+                                  not (a `elemVarSet` tyVarsOfType fun)
+                                = eta_reduce as rs fun
     eta_reduce tvs rs ty = (reverse tvs, reverse rs, ty)
-				
+                                
 
 ------------------------------------------------------
 buildDataCon :: FamInstEnvs 
             -> Name -> Bool
-	    -> [HsBang] 
-	    -> [Name]			-- Field labels
-	    -> [TyVar] -> [TyVar]	-- Univ and ext 
+            -> [HsBang] 
+            -> [Name]                   -- Field labels
+            -> [TyVar] -> [TyVar]       -- Univ and ext 
             -> [(TyVar,Type)]           -- Equality spec
-	    -> ThetaType		-- Does not include the "stupid theta"
-					-- or the GADT equalities
-	    -> [Type] -> Type		-- Argument and result types
-	    -> TyCon			-- Rep tycon
-	    -> TcRnIf m n DataCon
+            -> ThetaType                -- Does not include the "stupid theta"
+                                        -- or the GADT equalities
+            -> [Type] -> Type           -- Argument and result types
+            -> TyCon                    -- Rep tycon
+            -> TcRnIf m n DataCon
 -- A wrapper for DataCon.mkDataCon that
 --   a) makes the worker Id
 --   b) makes the wrapper Id if necessary, including
---	allocating its unique (hence monadic)
+--      allocating its unique (hence monadic)
 buildDataCon fam_envs src_name declared_infix arg_stricts field_lbls
-	     univ_tvs ex_tvs eq_spec ctxt arg_tys res_ty rep_tycon
-  = do	{ wrap_name <- newImplicitBinder src_name mkDataConWrapperOcc
-	; work_name <- newImplicitBinder src_name mkDataConWorkerOcc
-	-- This last one takes the name of the data constructor in the source
-	-- code, which (for Haskell source anyway) will be in the DataName name
-	-- space, and puts it into the VarName name space
+             univ_tvs ex_tvs eq_spec ctxt arg_tys res_ty rep_tycon
+  = do  { wrap_name <- newImplicitBinder src_name mkDataConWrapperOcc
+        ; work_name <- newImplicitBinder src_name mkDataConWorkerOcc
+        -- This last one takes the name of the data constructor in the source
+        -- code, which (for Haskell source anyway) will be in the DataName name
+        -- space, and puts it into the VarName name space
 
         ; us <- newUniqueSupply
         ; dflags <- getDynFlags
-	; let
-		stupid_ctxt = mkDataConStupidTheta rep_tycon arg_tys univ_tvs
-		data_con = mkDataCon src_name declared_infix
-				     arg_stricts field_lbls
-				     univ_tvs ex_tvs eq_spec ctxt
-				     arg_tys res_ty rep_tycon
-				     stupid_ctxt dc_wrk dc_rep
+        ; let
+                stupid_ctxt = mkDataConStupidTheta rep_tycon arg_tys univ_tvs
+                data_con = mkDataCon src_name declared_infix
+                                     arg_stricts field_lbls
+                                     univ_tvs ex_tvs eq_spec ctxt
+                                     arg_tys res_ty rep_tycon
+                                     stupid_ctxt dc_wrk dc_rep
                 dc_wrk = mkDataConWorkId work_name data_con
                 dc_rep = initUs_ us (mkDataConRep dflags fam_envs wrap_name data_con)
 
-	; return data_con }
+        ; return data_con }
 
 
 -- The stupid context for a data constructor should be limited to
 -- the type variables mentioned in the arg_tys
 -- ToDo: Or functionally dependent on?  
---	 This whole stupid theta thing is, well, stupid.
+--       This whole stupid theta thing is, well, stupid.
 mkDataConStupidTheta :: TyCon -> [Type] -> [TyVar] -> [PredType]
 mkDataConStupidTheta tycon arg_tys univ_tvs
-  | null stupid_theta = []	-- The common case
-  | otherwise 	      = filter in_arg_tys stupid_theta
+  | null stupid_theta = []      -- The common case
+  | otherwise         = filter in_arg_tys stupid_theta
   where
-    tc_subst	 = zipTopTvSubst (tyConTyVars tycon) (mkTyVarTys univ_tvs)
+    tc_subst     = zipTopTvSubst (tyConTyVars tycon) (mkTyVarTys univ_tvs)
     stupid_theta = substTheta tc_subst (tyConStupidTheta tycon)
-	-- Start by instantiating the master copy of the 
-	-- stupid theta, taken from the TyCon
+        -- Start by instantiating the master copy of the 
+        -- stupid theta, taken from the TyCon
 
     arg_tyvars      = tyVarsOfTypes arg_tys
     in_arg_tys pred = not $ isEmptyVarSet $ 
-		      tyVarsOfType pred `intersectVarSet` arg_tyvars
+                      tyVarsOfType pred `intersectVarSet` arg_tyvars
 \end{code}
 
 
@@ -185,97 +179,97 @@ type TcMethInfo = (Name, DefMethSpec, Type)
         -- A temporary intermediate, to communicate between 
         -- tcClassSigs and buildClass.
 
-buildClass :: Bool		-- True <=> do not include unfoldings 
-				--	    on dict selectors
-				-- Used when importing a class without -O
-	   -> Name -> [TyVar] -> [Role] -> ThetaType
-	   -> [FunDep TyVar]		   -- Functional dependencies
-	   -> [ClassATItem]		   -- Associated types
-	   -> [TcMethInfo]                 -- Method info
-	   -> ClassMinimalDef              -- Minimal complete definition
-	   -> RecFlag			   -- Info for type constructor
-	   -> TcRnIf m n Class
+buildClass :: Bool              -- True <=> do not include unfoldings 
+                                --          on dict selectors
+                                -- Used when importing a class without -O
+           -> Name -> [TyVar] -> [Role] -> ThetaType
+           -> [FunDep TyVar]               -- Functional dependencies
+           -> [ClassATItem]                -- Associated types
+           -> [TcMethInfo]                 -- Method info
+           -> ClassMinimalDef              -- Minimal complete definition
+           -> RecFlag                      -- Info for type constructor
+           -> TcRnIf m n Class
 
 buildClass no_unf tycon_name tvs roles sc_theta fds at_items sig_stuff mindef tc_isrec
-  = fixM  $ \ rec_clas -> 	-- Only name generation inside loop
-    do	{ traceIf (text "buildClass")
+  = fixM  $ \ rec_clas ->       -- Only name generation inside loop
+    do  { traceIf (text "buildClass")
         ; dflags <- getDynFlags
 
-	; datacon_name <- newImplicitBinder tycon_name mkClassDataConOcc
-		-- The class name is the 'parent' for this datacon, not its tycon,
-		-- because one should import the class to get the binding for 
-		-- the datacon
+        ; datacon_name <- newImplicitBinder tycon_name mkClassDataConOcc
+                -- The class name is the 'parent' for this datacon, not its tycon,
+                -- because one should import the class to get the binding for 
+                -- the datacon
 
 
-	; op_items <- mapM (mk_op_item rec_clas) sig_stuff
-	  		-- Build the selector id and default method id
+        ; op_items <- mapM (mk_op_item rec_clas) sig_stuff
+                        -- Build the selector id and default method id
 
-	      -- Make selectors for the superclasses 
-	; sc_sel_names <- mapM  (newImplicitBinder tycon_name . mkSuperDictSelOcc) 
-				[1..length sc_theta]
+              -- Make selectors for the superclasses 
+        ; sc_sel_names <- mapM  (newImplicitBinder tycon_name . mkSuperDictSelOcc) 
+                                [1..length sc_theta]
         ; let sc_sel_ids = [ mkDictSelId dflags no_unf sc_name rec_clas 
                            | sc_name <- sc_sel_names]
-	      -- We number off the Dict superclass selectors, 1, 2, 3 etc so that we 
-	      -- can construct names for the selectors. Thus
-	      --      class (C a, C b) => D a b where ...
-	      -- gives superclass selectors
-	      --      D_sc1, D_sc2
-	      -- (We used to call them D_C, but now we can have two different
-	      --  superclasses both called C!)
-	
-	; let use_newtype = isSingleton arg_tys
-		-- Use a newtype if the data constructor 
-		--   (a) has exactly one value field
-		--       i.e. exactly one operation or superclass taken together
+              -- We number off the Dict superclass selectors, 1, 2, 3 etc so that we 
+              -- can construct names for the selectors. Thus
+              --      class (C a, C b) => D a b where ...
+              -- gives superclass selectors
+              --      D_sc1, D_sc2
+              -- (We used to call them D_C, but now we can have two different
+              --  superclasses both called C!)
+        
+        ; let use_newtype = isSingleton arg_tys
+                -- Use a newtype if the data constructor 
+                --   (a) has exactly one value field
+                --       i.e. exactly one operation or superclass taken together
                 --   (b) that value is of lifted type (which they always are, because
                 --       we box equality superclasses)
-		-- See note [Class newtypes and equality predicates]
+                -- See note [Class newtypes and equality predicates]
 
-		-- We treat the dictionary superclasses as ordinary arguments.  
+                -- We treat the dictionary superclasses as ordinary arguments.  
                 -- That means that in the case of
-		--     class C a => D a
-		-- we don't get a newtype with no arguments!
-	      args      = sc_sel_names ++ op_names
-	      op_tys	= [ty | (_,_,ty) <- sig_stuff]
-	      op_names  = [op | (op,_,_) <- sig_stuff]
-	      arg_tys   = sc_theta ++ op_tys
+                --     class C a => D a
+                -- we don't get a newtype with no arguments!
+              args      = sc_sel_names ++ op_names
+              op_tys    = [ty | (_,_,ty) <- sig_stuff]
+              op_names  = [op | (op,_,_) <- sig_stuff]
+              arg_tys   = sc_theta ++ op_tys
               rec_tycon = classTyCon rec_clas
                
-	; dict_con <- buildDataCon (panic "buildClass: FamInstEnvs")
+        ; dict_con <- buildDataCon (panic "buildClass: FamInstEnvs")
                                    datacon_name
-				   False 	-- Not declared infix
-				   (map (const HsNoBang) args)
-				   [{- No fields -}]
-				   tvs [{- no existentials -}]
+                                   False        -- Not declared infix
+                                   (map (const HsNoBang) args)
+                                   [{- No fields -}]
+                                   tvs [{- no existentials -}]
                                    [{- No GADT equalities -}] 
                                    [{- No theta -}]
                                    arg_tys
-				   (mkTyConApp rec_tycon (mkTyVarTys tvs))
-				   rec_tycon
-
-	; rhs <- if use_newtype
-		 then mkNewTyConRhs tycon_name rec_tycon dict_con
-		 else return (mkDataTyConRhs [dict_con])
-
-	; let {	clas_kind = mkPiKinds tvs constraintKind
-
- 	      ; tycon = mkClassTyCon tycon_name clas_kind tvs roles
- 	                             rhs rec_clas tc_isrec
-		-- A class can be recursive, and in the case of newtypes 
-		-- this matters.  For example
-		-- 	class C a where { op :: C b => a -> b -> Int }
-		-- Because C has only one operation, it is represented by
-		-- a newtype, and it should be a *recursive* newtype.
-		-- [If we don't make it a recursive newtype, we'll expand the
-		-- newtype like a synonym, but that will lead to an infinite
-		-- type]
-
-	      ; result = mkClass tvs fds 
-			         sc_theta sc_sel_ids at_items
-				 op_items mindef tycon
-	      }
-	; traceIf (text "buildClass" <+> ppr tycon) 
-	; return result }
+                                   (mkTyConApp rec_tycon (mkTyVarTys tvs))
+                                   rec_tycon
+
+        ; rhs <- if use_newtype
+                 then mkNewTyConRhs tycon_name rec_tycon dict_con
+                 else return (mkDataTyConRhs [dict_con])
+
+        ; let { clas_kind = mkPiKinds tvs constraintKind
+
+              ; tycon = mkClassTyCon tycon_name clas_kind tvs roles
+                                     rhs rec_clas tc_isrec
+                -- A class can be recursive, and in the case of newtypes 
+                -- this matters.  For example
+                --      class C a where { op :: C b => a -> b -> Int }
+                -- Because C has only one operation, it is represented by
+                -- a newtype, and it should be a *recursive* newtype.
+                -- [If we don't make it a recursive newtype, we'll expand the
+                -- newtype like a synonym, but that will lead to an infinite
+                -- type]
+
+              ; result = mkClass tvs fds 
+                                 sc_theta sc_sel_ids at_items
+                                 op_items mindef tycon
+              }
+        ; traceIf (text "buildClass" <+> ppr tycon) 
+        ; return result }
   where
     mk_op_item :: Class -> TcMethInfo -> TcRnIf n m ClassOpItem
     mk_op_item rec_clas (op_name, dm_spec, _) 
@@ -283,24 +277,24 @@ buildClass no_unf tycon_name tvs roles sc_theta fds at_items sig_stuff mindef tc
            ; dm_info <- case dm_spec of
                           NoDM      -> return NoDefMeth
                           GenericDM -> do { dm_name <- newImplicitBinder op_name mkGenDefMethodOcc
-			  	          ; return (GenDefMeth dm_name) }
+                                          ; return (GenDefMeth dm_name) }
                           VanillaDM -> do { dm_name <- newImplicitBinder op_name mkDefaultMethodOcc
-			  	          ; return (DefMeth dm_name) }
+                                          ; return (DefMeth dm_name) }
            ; return (mkDictSelId dflags no_unf op_name rec_clas, dm_info) }
 \end{code}
 
 Note [Class newtypes and equality predicates]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Consider
-	class (a ~ F b) => C a b where
-	  op :: a -> b
+        class (a ~ F b) => C a b where
+          op :: a -> b
 
 We cannot represent this by a newtype, even though it's not
 existential, because there are two value fields (the equality
 predicate and op. See Trac #2238
 
 Moreover, 
-	  class (a ~ F b) => C a b where {}
+          class (a ~ F b) => C a b where {}
 Here we can't use a newtype either, even though there is only
 one field, because equality predicates are unboxed, and classes
 are boxed.
diff --git a/compiler/iface/IfaceEnv.lhs b/compiler/iface/IfaceEnv.lhs
index 1410675..7db4aa8 100644
--- a/compiler/iface/IfaceEnv.lhs
+++ b/compiler/iface/IfaceEnv.lhs
@@ -1,25 +1,19 @@
 (c) The University of Glasgow 2002-2006
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module IfaceEnv (
-	newGlobalBinder, newImplicitBinder, 
-	lookupIfaceTop,
-	lookupOrig, lookupOrigNameCache, extendNameCache,
-	newIfaceName, newIfaceNames,
-	extendIfaceIdEnv, extendIfaceTyVarEnv, 
-	tcIfaceLclId, tcIfaceTyVar, lookupIfaceTyVar,
+        newGlobalBinder, newImplicitBinder, 
+        lookupIfaceTop,
+        lookupOrig, lookupOrigNameCache, extendNameCache,
+        newIfaceName, newIfaceNames,
+        extendIfaceIdEnv, extendIfaceTyVarEnv, 
+        tcIfaceLclId, tcIfaceTyVar, lookupIfaceTyVar,
 
-	ifaceExportNames,
+        ifaceExportNames,
 
-	-- Name-cache stuff
-	allocateGlobalBinder, initNameCache, updNameCache,
+        -- Name-cache stuff
+        allocateGlobalBinder, initNameCache, updNameCache,
         getNameCache, mkNameCacheUpdater, NameCacheUpdater(..)
    ) where
 
@@ -50,9 +44,9 @@ import Data.IORef    ( atomicModifyIORef, readIORef )
 
 
 %*********************************************************
-%*							*
-	Allocating new Names in the Name Cache
-%*							*
+%*                                                      *
+        Allocating new Names in the Name Cache
+%*                                                      *
 %*********************************************************
 
 Note [The Name Cache]
@@ -82,7 +76,7 @@ newGlobalBinder :: Module -> OccName -> SrcSpan -> TcRnIf a b Name
 -- moment when we know its Module and SrcLoc in their full glory
 
 newGlobalBinder mod occ loc
-  = do mod `seq` occ `seq` return ()	-- See notes with lookupOrig
+  = do mod `seq` occ `seq` return ()    -- See notes with lookupOrig
 --     traceIf (text "newGlobalBinder" <+> ppr mod <+> ppr occ <+> ppr loc)
        updNameCache $ \name_cache ->
          allocateGlobalBinder name_cache mod occ loc
@@ -102,13 +96,13 @@ allocateGlobalBinder name_supply mod occ loc
         -- get different SrcLocs can can be reported as such.
         --
         -- Possible other reason: it might be in the cache because we
-        -- 	encountered an occurrence before the binding site for an
-        --	implicitly-imported Name.  Perhaps the current SrcLoc is
-        --	better... but not really: it'll still just say 'imported'
+        --      encountered an occurrence before the binding site for an
+        --      implicitly-imported Name.  Perhaps the current SrcLoc is
+        --      better... but not really: it'll still just say 'imported'
         --
         -- IMPORTANT: Don't mess with wired-in names.
-        -- 	      Their wired-in-ness is in their NameSort
-        --	      and their Module is correct.
+        --            Their wired-in-ness is in their NameSort
+        --            and their Module is correct.
 
         Just name | isWiredInName name -> (name_supply, name)
                   | mod /= iNTERACTIVE -> (new_name_supply, name')
@@ -138,20 +132,20 @@ for the new Name as for the old, hence this special case.
 See also Note [Outputable Orig RdrName] in HscTypes.
 -}
 
-newImplicitBinder :: Name			-- Base name
-	          -> (OccName -> OccName) 	-- Occurrence name modifier
-	          -> TcRnIf m n Name		-- Implicit name
+newImplicitBinder :: Name                       -- Base name
+                  -> (OccName -> OccName)       -- Occurrence name modifier
+                  -> TcRnIf m n Name            -- Implicit name
 -- Called in BuildTyCl to allocate the implicit binders of type/class decls
 -- For source type/class decls, this is the first occurrence
 -- For iface ones, the LoadIface has alrady allocated a suitable name in the cache
 newImplicitBinder base_name mk_sys_occ
   | Just mod <- nameModule_maybe base_name
   = newGlobalBinder mod occ loc
-  | otherwise	  	-- When typechecking a [d| decl bracket |], 
-    			-- TH generates types, classes etc with Internal names,
-			-- so we follow suit for the implicit binders
-  = do	{ uniq <- newUnique
-	; return (mkInternalName uniq occ loc) }
+  | otherwise           -- When typechecking a [d| decl bracket |], 
+                        -- TH generates types, classes etc with Internal names,
+                        -- so we follow suit for the implicit binders
+  = do  { uniq <- newUnique
+        ; return (mkInternalName uniq occ loc) }
   where
     occ = mk_sys_occ (nameOccName base_name)
     loc = nameSrcSpan base_name
@@ -161,19 +155,19 @@ ifaceExportNames exports = return exports
 
 lookupOrig :: Module -> OccName ->  TcRnIf a b Name
 lookupOrig mod occ
-  = do 	{ 	-- First ensure that mod and occ are evaluated
-		-- If not, chaos can ensue:
-		-- 	we read the name-cache
-		-- 	then pull on mod (say)
-		--	which does some stuff that modifies the name cache
-		-- This did happen, with tycon_mod in TcIface.tcIfaceAlt (DataAlt..)
-	  mod `seq` occ `seq` return ()	
---	; traceIf (text "lookup_orig" <+> ppr mod <+> ppr occ)
+  = do  {       -- First ensure that mod and occ are evaluated
+                -- If not, chaos can ensue:
+                --      we read the name-cache
+                --      then pull on mod (say)
+                --      which does some stuff that modifies the name cache
+                -- This did happen, with tycon_mod in TcIface.tcIfaceAlt (DataAlt..)
+          mod `seq` occ `seq` return () 
+--      ; traceIf (text "lookup_orig" <+> ppr mod <+> ppr occ)
 
         ; updNameCache $ \name_cache ->
             case lookupOrigNameCache (nsNames name_cache) mod occ of {
-	      Just name -> (name_cache, name);
-	      Nothing   ->
+              Just name -> (name_cache, name);
+              Nothing   ->
               case takeUniqFromSupply (nsUniqs name_cache) of {
               (uniq, us) ->
                   let
@@ -184,9 +178,9 @@ lookupOrig mod occ
 \end{code}
 
 %************************************************************************
-%*									*
-		Name cache access
-%*									*
+%*                                                                      *
+                Name cache access
+%*                                                                      *
 %************************************************************************
 
 See Note [The Name Cache] above.
@@ -196,21 +190,21 @@ lookupOrigNameCache :: OrigNameCache -> Module -> OccName -> Maybe Name
 lookupOrigNameCache _ mod occ
   -- Don't need to mention gHC_UNIT here because it is explicitly
   -- included in TysWiredIn.wiredInTyCons
-  | mod == gHC_TUPLE || mod == gHC_PRIM,		-- Boxed tuples from one, 
-    Just tup_info <- isTupleOcc_maybe occ	-- unboxed from the other
-  = 	-- Special case for tuples; there are too many
-	-- of them to pre-populate the original-name cache
+  | mod == gHC_TUPLE || mod == gHC_PRIM,                -- Boxed tuples from one, 
+    Just tup_info <- isTupleOcc_maybe occ       -- unboxed from the other
+  =     -- Special case for tuples; there are too many
+        -- of them to pre-populate the original-name cache
     Just (mk_tup_name tup_info)
   where
     mk_tup_name (ns, sort, arity)
-	| ns == tcName   = tyConName (tupleTyCon sort arity)
-	| ns == dataName = dataConName (tupleCon sort arity)
-	| otherwise      = Var.varName (dataConWorkId (tupleCon sort arity))
+        | ns == tcName   = tyConName (tupleTyCon sort arity)
+        | ns == dataName = dataConName (tupleCon sort arity)
+        | otherwise      = Var.varName (dataConWorkId (tupleCon sort arity))
 
-lookupOrigNameCache nc mod occ	-- The normal case
+lookupOrigNameCache nc mod occ  -- The normal case
   = case lookupModuleEnv nc mod of
-	Nothing      -> Nothing
-	Just occ_env -> lookupOccEnv occ_env occ
+        Nothing      -> Nothing
+        Just occ_env -> lookupOccEnv occ_env occ
 
 extendOrigNameCache :: OrigNameCache -> Name -> OrigNameCache
 extendOrigNameCache nc name 
@@ -225,7 +219,7 @@ extendNameCache nc mod occ name
 
 getNameCache :: TcRnIf a b NameCache
 getNameCache = do { HscEnv { hsc_NC = nc_var } <- getTopEnv; 
-		    readMutVar nc_var }
+                    readMutVar nc_var }
 
 updNameCache :: (NameCache -> (NameCache, c)) -> TcRnIf a b c
 updNameCache upd_fn = do
@@ -252,7 +246,7 @@ mkNameCacheUpdater = do
 initNameCache :: UniqSupply -> [Name] -> NameCache
 initNameCache us names
   = NameCache { nsUniqs = us,
-		nsNames = initOrigNames names }
+                nsNames = initOrigNames names }
 
 initOrigNames :: [Name] -> OrigNameCache
 initOrigNames names = foldl extendOrigNameCache emptyModuleEnv names
@@ -261,70 +255,70 @@ initOrigNames names = foldl extendOrigNameCache emptyModuleEnv names
 
 
 %************************************************************************
-%*									*
-		Type variables and local Ids
-%*									*
+%*                                                                      *
+                Type variables and local Ids
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 tcIfaceLclId :: FastString -> IfL Id
 tcIfaceLclId occ
-  = do	{ lcl <- getLclEnv
-	; case (lookupUFM (if_id_env lcl) occ) of
+  = do  { lcl <- getLclEnv
+        ; case (lookupUFM (if_id_env lcl) occ) of
             Just ty_var -> return ty_var
             Nothing     -> failIfM (text "Iface id out of scope: " <+> ppr occ)
         }
 
 extendIfaceIdEnv :: [Id] -> IfL a -> IfL a
 extendIfaceIdEnv ids thing_inside
-  = do	{ env <- getLclEnv
-	; let { id_env' = addListToUFM (if_id_env env) pairs
-	      ;	pairs   = [(occNameFS (getOccName id), id) | id <- ids] }
-	; setLclEnv (env { if_id_env = id_env' }) thing_inside }
+  = do  { env <- getLclEnv
+        ; let { id_env' = addListToUFM (if_id_env env) pairs
+              ; pairs   = [(occNameFS (getOccName id), id) | id <- ids] }
+        ; setLclEnv (env { if_id_env = id_env' }) thing_inside }
 
 
 tcIfaceTyVar :: FastString -> IfL TyVar
 tcIfaceTyVar occ
-  = do	{ lcl <- getLclEnv
-	; case (lookupUFM (if_tv_env lcl) occ) of
+  = do  { lcl <- getLclEnv
+        ; case (lookupUFM (if_tv_env lcl) occ) of
             Just ty_var -> return ty_var
             Nothing     -> failIfM (text "Iface type variable out of scope: " <+> ppr occ)
         }
 
 lookupIfaceTyVar :: FastString -> IfL (Maybe TyVar)
 lookupIfaceTyVar occ
-  = do	{ lcl <- getLclEnv
-	; return (lookupUFM (if_tv_env lcl) occ) }
+  = do  { lcl <- getLclEnv
+        ; return (lookupUFM (if_tv_env lcl) occ) }
 
 extendIfaceTyVarEnv :: [TyVar] -> IfL a -> IfL a
 extendIfaceTyVarEnv tyvars thing_inside
-  = do	{ env <- getLclEnv
-	; let { tv_env' = addListToUFM (if_tv_env env) pairs
-	      ;	pairs   = [(occNameFS (getOccName tv), tv) | tv <- tyvars] }
-	; setLclEnv (env { if_tv_env = tv_env' }) thing_inside }
+  = do  { env <- getLclEnv
+        ; let { tv_env' = addListToUFM (if_tv_env env) pairs
+              ; pairs   = [(occNameFS (getOccName tv), tv) | tv <- tyvars] }
+        ; setLclEnv (env { if_tv_env = tv_env' }) thing_inside }
 \end{code}
 
 
 %************************************************************************
-%*									*
-		Getting from RdrNames to Names
-%*									*
+%*                                                                      *
+                Getting from RdrNames to Names
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 lookupIfaceTop :: OccName -> IfL Name
 -- Look up a top-level name from the current Iface module
 lookupIfaceTop occ
-  = do	{ env <- getLclEnv; lookupOrig (if_mod env) occ }
+  = do  { env <- getLclEnv; lookupOrig (if_mod env) occ }
 
 newIfaceName :: OccName -> IfL Name
 newIfaceName occ
-  = do	{ uniq <- newUnique
-	; return $! mkInternalName uniq occ noSrcSpan }
+  = do  { uniq <- newUnique
+        ; return $! mkInternalName uniq occ noSrcSpan }
 
 newIfaceNames :: [OccName] -> IfL [Name]
 newIfaceNames occs
-  = do	{ uniqs <- newUniqueSupply
-	; return [ mkInternalName uniq occ noSrcSpan
-		 | (occ,uniq) <- occs `zip` uniqsFromSupply uniqs] }
+  = do  { uniqs <- newUniqueSupply
+        ; return [ mkInternalName uniq occ noSrcSpan
+                 | (occ,uniq) <- occs `zip` uniqsFromSupply uniqs] }
 \end{code}
